// tslint:disable
/**
 * OatMilk.Backend.Api
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v1
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { HttpMethods, QueryConfig, ResponseBody, ResponseText } from 'redux-query';
import * as runtime from '../runtime';
import {
    CharacterRequest,
    CharacterRequestFromJSON,
    CharacterRequestToJSON,
    CharacterResponse,
    CharacterResponseFromJSON,
    CharacterResponseToJSON,
    CharacterResponsePageResponse,
    CharacterResponsePageResponseFromJSON,
    CharacterResponsePageResponseToJSON,
    ErrorResponse,
    ErrorResponseFromJSON,
    ErrorResponseToJSON,
} from '../models';

export interface CharacterFullGetRequest {
    searchByName?: string;
    sortColumnName?: string;
    sortAscending?: boolean;
    pageIndex?: number;
    pageSize?: number;
}

export interface CharacterFullIdDeleteRequest {
    id: string;
}

export interface CharacterFullIdPutRequest {
    id: string;
    characterRequest?: CharacterRequest;
}

export interface CharacterFullIdentifierGetRequest {
    identifier: string;
}

export interface CharacterFullPostRequest {
    characterRequest?: CharacterRequest;
}


/**
 * Get a paginated, filtered and sorted list of all existing characters, with all details.
 */
function characterFullGetRaw<T>(requestParameters: CharacterFullGetRequest, requestConfig: runtime.TypedQueryConfig<T, CharacterResponsePageResponse> = {}): QueryConfig<T> {
    let queryParameters = null;

    queryParameters = {};


    if (requestParameters.searchByName !== undefined) {
        queryParameters['SearchByName'] = requestParameters.searchByName;
    }


    if (requestParameters.sortColumnName !== undefined) {
        queryParameters['SortColumnName'] = requestParameters.sortColumnName;
    }


    if (requestParameters.sortAscending !== undefined) {
        queryParameters['SortAscending'] = requestParameters.sortAscending;
    }


    if (requestParameters.pageIndex !== undefined) {
        queryParameters['PageIndex'] = requestParameters.pageIndex;
    }


    if (requestParameters.pageSize !== undefined) {
        queryParameters['PageSize'] = requestParameters.pageSize;
    }

    const headerParameters : runtime.HttpHeaders = {};


    const { meta = {} } = requestConfig;

    const config: QueryConfig<T> = {
        url: `${runtime.Configuration.basePath}/Character/full`,
        meta,
        update: requestConfig.update,
        queryKey: requestConfig.queryKey,
        optimisticUpdate: requestConfig.optimisticUpdate,
        force: requestConfig.force,
        rollback: requestConfig.rollback,
        options: {
            method: 'GET',
            headers: headerParameters,
        },
        body: queryParameters,
    };

    const { transform: requestTransform } = requestConfig;
    if (requestTransform) {
        config.transform = (body: ResponseBody, text: ResponseBody) => requestTransform(CharacterResponsePageResponseFromJSON(body), text);
    }

    return config;
}

/**
* Get a paginated, filtered and sorted list of all existing characters, with all details.
*/
export function characterFullGet<T>(requestParameters: CharacterFullGetRequest, requestConfig?: runtime.TypedQueryConfig<T, CharacterResponsePageResponse>): QueryConfig<T> {
    return characterFullGetRaw(requestParameters, requestConfig);
}

/**
 * Delete an existing character by ID.
 */
function characterFullIdDeleteRaw<T>(requestParameters: CharacterFullIdDeleteRequest, requestConfig: runtime.TypedQueryConfig<T, void> = {}): QueryConfig<T> {
    if (requestParameters.id === null || requestParameters.id === undefined) {
        throw new runtime.RequiredError('id','Required parameter requestParameters.id was null or undefined when calling characterFullIdDelete.');
    }

    let queryParameters = null;


    const headerParameters : runtime.HttpHeaders = {};


    const { meta = {} } = requestConfig;

    const config: QueryConfig<T> = {
        url: `${runtime.Configuration.basePath}/Character/full/{id}`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        meta,
        update: requestConfig.update,
        queryKey: requestConfig.queryKey,
        optimisticUpdate: requestConfig.optimisticUpdate,
        force: requestConfig.force,
        rollback: requestConfig.rollback,
        options: {
            method: 'DELETE',
            headers: headerParameters,
        },
        body: queryParameters,
    };

    const { transform: requestTransform } = requestConfig;
    if (requestTransform) {
    }

    return config;
}

/**
* Delete an existing character by ID.
*/
export function characterFullIdDelete<T>(requestParameters: CharacterFullIdDeleteRequest, requestConfig?: runtime.TypedQueryConfig<T, void>): QueryConfig<T> {
    return characterFullIdDeleteRaw(requestParameters, requestConfig);
}

/**
 * Update an existing character by ID.
 */
function characterFullIdPutRaw<T>(requestParameters: CharacterFullIdPutRequest, requestConfig: runtime.TypedQueryConfig<T, CharacterResponse> = {}): QueryConfig<T> {
    if (requestParameters.id === null || requestParameters.id === undefined) {
        throw new runtime.RequiredError('id','Required parameter requestParameters.id was null or undefined when calling characterFullIdPut.');
    }

    let queryParameters = null;


    const headerParameters : runtime.HttpHeaders = {};

    headerParameters['Content-Type'] = 'application/json';


    const { meta = {} } = requestConfig;

    const config: QueryConfig<T> = {
        url: `${runtime.Configuration.basePath}/Character/full/{id}`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        meta,
        update: requestConfig.update,
        queryKey: requestConfig.queryKey,
        optimisticUpdate: requestConfig.optimisticUpdate,
        force: requestConfig.force,
        rollback: requestConfig.rollback,
        options: {
            method: 'PUT',
            headers: headerParameters,
        },
        body: queryParameters || CharacterRequestToJSON(requestParameters.characterRequest),
    };

    const { transform: requestTransform } = requestConfig;
    if (requestTransform) {
        config.transform = (body: ResponseBody, text: ResponseBody) => requestTransform(CharacterResponseFromJSON(body), text);
    }

    return config;
}

/**
* Update an existing character by ID.
*/
export function characterFullIdPut<T>(requestParameters: CharacterFullIdPutRequest, requestConfig?: runtime.TypedQueryConfig<T, CharacterResponse>): QueryConfig<T> {
    return characterFullIdPutRaw(requestParameters, requestConfig);
}

/**
 * Get an existing character by its human-readable identifier.
 */
function characterFullIdentifierGetRaw<T>(requestParameters: CharacterFullIdentifierGetRequest, requestConfig: runtime.TypedQueryConfig<T, CharacterResponse> = {}): QueryConfig<T> {
    if (requestParameters.identifier === null || requestParameters.identifier === undefined) {
        throw new runtime.RequiredError('identifier','Required parameter requestParameters.identifier was null or undefined when calling characterFullIdentifierGet.');
    }

    let queryParameters = null;


    const headerParameters : runtime.HttpHeaders = {};


    const { meta = {} } = requestConfig;

    const config: QueryConfig<T> = {
        url: `${runtime.Configuration.basePath}/Character/full/{identifier}`.replace(`{${"identifier"}}`, encodeURIComponent(String(requestParameters.identifier))),
        meta,
        update: requestConfig.update,
        queryKey: requestConfig.queryKey,
        optimisticUpdate: requestConfig.optimisticUpdate,
        force: requestConfig.force,
        rollback: requestConfig.rollback,
        options: {
            method: 'GET',
            headers: headerParameters,
        },
        body: queryParameters,
    };

    const { transform: requestTransform } = requestConfig;
    if (requestTransform) {
        config.transform = (body: ResponseBody, text: ResponseBody) => requestTransform(CharacterResponseFromJSON(body), text);
    }

    return config;
}

/**
* Get an existing character by its human-readable identifier.
*/
export function characterFullIdentifierGet<T>(requestParameters: CharacterFullIdentifierGetRequest, requestConfig?: runtime.TypedQueryConfig<T, CharacterResponse>): QueryConfig<T> {
    return characterFullIdentifierGetRaw(requestParameters, requestConfig);
}

/**
 * Create a character.
 */
function characterFullPostRaw<T>(requestParameters: CharacterFullPostRequest, requestConfig: runtime.TypedQueryConfig<T, CharacterResponse> = {}): QueryConfig<T> {
    let queryParameters = null;


    const headerParameters : runtime.HttpHeaders = {};

    headerParameters['Content-Type'] = 'application/json';


    const { meta = {} } = requestConfig;

    const config: QueryConfig<T> = {
        url: `${runtime.Configuration.basePath}/Character/full`,
        meta,
        update: requestConfig.update,
        queryKey: requestConfig.queryKey,
        optimisticUpdate: requestConfig.optimisticUpdate,
        force: requestConfig.force,
        rollback: requestConfig.rollback,
        options: {
            method: 'POST',
            headers: headerParameters,
        },
        body: queryParameters || CharacterRequestToJSON(requestParameters.characterRequest),
    };

    const { transform: requestTransform } = requestConfig;
    if (requestTransform) {
        config.transform = (body: ResponseBody, text: ResponseBody) => requestTransform(CharacterResponseFromJSON(body), text);
    }

    return config;
}

/**
* Create a character.
*/
export function characterFullPost<T>(requestParameters: CharacterFullPostRequest, requestConfig?: runtime.TypedQueryConfig<T, CharacterResponse>): QueryConfig<T> {
    return characterFullPostRaw(requestParameters, requestConfig);
}

